<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:of="scpf.org:office" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:java="http://xml.apache.org/xslt/java" xmlns="http://www.utc.fr/ics/scenari/v3/primitive" exclude-result-prefixes="of sp java " >

<xsl:param name="vSpace"/>
<xsl:param name="vCode"/>

<xsl:template match="/sc:item">
<xsl:apply-templates select="of:paper"/>
</xsl:template>

<xsl:template match="sc:item/of:paper">
	<title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="of:paperM"><xsl:value-of select="sp:title"/></xsl:for-each></title>
<xsl:apply-templates/>
</xsl:template>


<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:paper/sp:pre[@sc:refUri]">
<xsl:if test="preceding-sibling::sp:*[@sc:refUri=current()/@sc:refUri and (name()='sp:pre' or name()='sp:chap' or name()='sp:post')]">
<cPbs><pb msg="Un item a été référencé plusieurs fois !" typ="Error">
<xsl:value-of select="formatStr('Veuillez supprimer une des références à l&apos;&apos;item %s.', @sc:refUri)"/>
</pb></cPbs>
</xsl:if>
<attrRef nm="of_paper:pre" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:paper/sp:chap[@sc:refUri]">
<xsl:if test="preceding-sibling::sp:*[@sc:refUri=current()/@sc:refUri and (name()='sp:pre' or name()='sp:chap' or name()='sp:post')]">
<cPbs><pb msg="Un item a été référencé plusieurs fois !" typ="Error">
<xsl:value-of select="formatStr('Veuillez supprimer une des références à l&apos;&apos;item %s.', @sc:refUri)"/>
</pb></cPbs>
</xsl:if>
<attrRef nm="of_paper:chap" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:paper/sp:post[@sc:refUri]">
<xsl:if test="preceding-sibling::sp:*[@sc:refUri=current()/@sc:refUri and (name()='sp:pre' or name()='sp:chap' or name()='sp:post')]">
<cPbs><pb msg="Un item a été référencé plusieurs fois !" typ="Error">
<xsl:value-of select="formatStr('Veuillez supprimer une des références à l&apos;&apos;item %s.', @sc:refUri)"/>
</pb></cPbs>
</xsl:if>
<attrRef nm="of_paper:post" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>



<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:extBlock[@role='img'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef nm="of_txt:extBlockTag:img" refUri="{@sc:refUri}"/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:extBlock[@role='anim'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef nm="of_txt:extBlockTag:anim" refUri="{@sc:refUri}"/>
</xsl:template>
				
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='def'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef nm="of_txt:uLinkTag:def" refUri="{@sc:refUri}"/>
</xsl:template>
			
				
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='ref'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef nm="of_txt:uLinkTag:ref" refUri="{@sc:refUri}"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='ico'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef nm="of_txt:inlineImgTag:ico" refUri="{@sc:refUri}"/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:optsPubWebM/sp:comments[@sc:refUri]">
<attrRef nm="of_optsPubWebM:comments:" refUri="{@sc:refUri}"/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:optsPubWebM/sp:rating[@sc:refUri]">
<attrRef nm="of_optsPubWebM:rating:" refUri="{@sc:refUri}"/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:optsPubWebM/sp:search[@sc:refUri]">
<attrRef nm="of_optsPubWebM:search:" refUri="{@sc:refUri}"/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:optsPubWebM/sp:stats[@sc:refUri]">
<attrRef nm="of_optsPubWebM:stats:" refUri="{@sc:refUri}"/>
</xsl:template>

				
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='ico'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:sTxt]">
<attrRef nm="of_sTxt:inlineImgTag:ico" refUri="{@sc:refUri}"/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:optsPubOdtM/sp:frontPage/sp:fpImg[@sc:refUri]">
<attrRef nm="of_optsPubOdtM:frontPage:fpImg:" refUri="{@sc:refUri}"/>
</xsl:template>

<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:section/sp:sec[@sc:refUri]">
<xsl:if test="preceding-sibling::sp:*[@sc:refUri=current()/@sc:refUri and (name()='sp:sec' or name()='sp:subSec')]">
<cPbs><pb msg="Un item a été référencé plusieurs fois !" typ="Error">
<xsl:value-of select="formatStr('Veuillez supprimer une des références à l&apos;&apos;item %s.', @sc:refUri)"/>
</pb></cPbs>
</xsl:if>
<attrRef nm="of_section:sec" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>

<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:eventList/sp:event[@sc:refUri]">
<attrRef nm="of_eventList:event" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>




<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:gallery/sp:img[@sc:refUri]">
<attrRef nm="of_gallery:img" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>

<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:fragment/sp:evtList[@sc:refUri]">
<attrRef nm="of_fragment:evtList" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:fragment/sp:gallery[@sc:refUri]">
<attrRef nm="of_fragment:gallery" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:fragment/sp:frag[@sc:refUri]">
<attrRef nm="of_fragment:frag" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>





<xsl:template match="text()|@*"/>
</xsl:stylesheet>